(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./PolygonPathGenerator"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.loadPolygonPath = exports.polygonPathName = void 0;
    const PolygonPathGenerator_1 = require("./PolygonPathGenerator");
    exports.polygonPathName = "polygonPathGenerator";
    async function loadPolygonPath(engine, refresh = true) {
        await engine.addPathGenerator(exports.polygonPathName, new PolygonPathGenerator_1.PolygonPathGenerator(), refresh);
    }
    exports.loadPolygonPath = loadPolygonPath;
});
